Index: issm/branches/trunk-jpl-damage/src/m/utils/OS/ispetsc.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/OS/ispetsc.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/OS/ispetsc.py	(revision 12878)
@@ -0,0 +1,37 @@
+import os
+from issmdir import *
+from MatlabFuncs import *
+
+def ispetsc():
+	"""
+	ISPETSC - figure out if PETSC package was compiled with ISSM
+ 
+	    Usage:
+	        flag=ispetsc();
+	"""
+
+	configfile=os.path.join(issmdir(),'bin','config.h')    #should find it in the install target
+	if not os.path.exists(configfile):
+		raise RuntimeError("File '%s' not found. ISSM has not been configured yet!" % configfile)
+
+	#go through the file, and recover the line we want
+	flag=2
+	try:
+		fid=open(configfile,'r')
+	except IOError as e:
+		raise IOError("could not open file: '%s'" % configfile)
+
+	for tline in fid:
+		if strncmp(tline,'/* #undef _HAVE_PETSC_ */',25):
+			flag=0
+			break
+		if  strncmp(tline,'#define _HAVE_PETSC_',20):
+			flag=1
+			break
+
+	fid.close()
+	if flag==2:
+		raise RuntimeError("could not determine whether PETSC was or was not compiled.")
+
+	return flag
+
Index: issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpin.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpin.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpin.m	(revision 12878)
@@ -35,5 +35,5 @@
 		[status,ISSM_DIR]=system('echo [%ISSM_DIR_WIN%]');
 		if status, 
-			error('scpin error message: could not find ISSM_DIR_WIN envirnoment variable');
+			error('scpin error message: could not find ISSM_DIR_WIN environment variable');
 		end
 		ISSM_DIR=ISSM_DIR(2:end-2);
Index: issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpin.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpin.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpin.py	(revision 12878)
@@ -0,0 +1,78 @@
+import socket
+import platform
+import subprocess
+import os
+import shutil
+from MatlabFuncs import *
+
+def scpin(host, login,port,path, packages):
+	"""
+	SCPIN get packages from host, using scp on unix, and pscp on windows
+ 
+	    usage: scpin(host,packages,path)
+ 
+ 
+	"""
+
+	#first get hostname
+	hostname=socket.gethostname().lower().split('.')[0]
+
+	#first be sure packages are not in the current directory, this could conflict with pscp on windows. 
+	#remove warnings in case the files do not exist
+	for package in packages:
+		try:
+			os.remove(package)
+		except OSError as e:
+			pass
+
+	#if hostname and host are the same, do a simple copy
+	if strcmpi(hostname,host):
+
+		for package in packages:
+			try:
+				shutil.copy(os.path.join(path,package),os.getcwd())    #keep going, even if success=0
+			except OSError as e:
+				pass
+
+	else:
+
+		if 'Windows' in platform.system():
+			#use the putty project pscp.exe: it should be in the path.
+		
+			#get ISSM_DIR variable
+			if 'ISSM_DIR_WIN' in os.environ:
+				ISSM_DIR=os.environ['ISSM_DIR_WIN'][1:-2]
+			else:
+				raise OSError("scpin error message: could not find ISSM_DIR_WIN environment variable.")
+
+			username=raw_input('Username: (quoted string) ')
+			key=raw_input('Key: (quoted string) ')
+
+			for package in packages:
+				try:
+					subprocess.check_call('%s/externalpackages/ssh/pscp.exe -l "%s" -pw "%s" %s:%s %s' % (ISSM_DIR,username,key,host,os.path.join(path,package),os.getcwd()),shell=True)
+				except CalledProcessError as e:
+					raise CalledProcessError("scpin error message: could not call putty pscp.")
+
+		else:
+			#just use standard unix scp
+			#string to copy multiple files using scp: 
+			if len(packages)==1:
+				string=packages[0]
+			else:
+				string='{'
+				for package in packages:
+					string+=packages[i]+','
+				string=string[:-1]+'}'
+
+
+			if port:
+				subprocess.call('scp -P %d %s@localhost:%s %s' % (port,login,os.path.join(path,string),os.getcwd),shell=True)
+			else:
+				subprocess.call('scp %s@%s:%s %s' % (login,host,os.path.join(path,string),os.getcwd),shell=True)
+		
+			#check scp worked
+			for package in packages:
+				if not os.path.exists(os.path.join('.',package)):
+					raise OSError("scpin error message: could not call scp on *nix system.")
+
Index: issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpout.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpout.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpout.m	(revision 12878)
@@ -26,5 +26,5 @@
 		[status,ISSM_DIR]=system('echo [%ISSM_DIR_WIN%]');
 		if status, 
-			error('scpout error message: could not find ISSM_DIR_WIN envirnoment variable');
+			error('scpout error message: could not find ISSM_DIR_WIN environment variable');
 		end
 		ISSM_DIR=ISSM_DIR(2:end-2);
Index: issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpout.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpout.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/OS/issmscpout.py	(revision 12878)
@@ -0,0 +1,60 @@
+import socket
+import platform
+import subprocess
+import os
+import shutil
+from MatlabFuncs import *
+
+def issmscpout(host,path,login,port,packages):
+	"""
+	SCPOUT send packages to a host, using scp on unix, and pscp on windows
+ 
+	    usage: scpout(host,path,packages)
+ 
+ 
+	"""
+
+	#get hostname
+	hostname=socket.gethostname().lower().split('.')[0]
+
+	#if hostname and host are the same, do a simple copy
+
+	if strcmpi(host,hostname):
+		for package in packages:
+			here=os.getcwd()
+			os.chdir(path)
+			shutil.rmtree(package)
+			subprocess.call('ln -s %s %s' % (os.path.join(here,package),path),shell=True)
+			os.chdir(here)
+	else:
+		if 'Windows' in platform.system():
+			#use the putty project pscp.exe: it should be in the path.
+		
+			#get ISSM_DIR variable
+			if 'ISSM_DIR_WIN' in os.environ:
+				ISSM_DIR=os.environ['ISSM_DIR_WIN'][1:-2]
+			else:
+				raise OSError("scpout error message: could not find ISSM_DIR_WIN environment variable.")
+
+			username=raw_input('Username: (quoted string) ')
+			key=raw_input('Key: (quoted string) ')
+
+			for package in packages:
+				try:
+					subprocess.check_call('%s/externalpackages/ssh/pscp.exe -l "%s" -pw "%s" %s %s:%s' % (ISSM_DIR,username,key,package,host,path),shell=True)
+				except CalledProcessError as e:
+					raise CalledProcessError("scpout error message: could not call putty pscp.")
+
+		else:
+			#just use standard unix scp
+			#create string of packages being sent
+			string=''
+			for package in packages:
+				string+=' '+package
+			string+=' '
+		
+			if port:
+				subprocess.call('scp -P %d %s %s@localhost:%s' % (port,string,login,path),shell=True)
+			else:
+				subprocess.call('scp %s %s@%s:%s' % (string,login,host,path),shell=True)
+
Index: issm/branches/trunk-jpl-damage/src/m/utils/OS/issmssh.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/OS/issmssh.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/OS/issmssh.m	(revision 12878)
@@ -18,5 +18,5 @@
 		[status,ISSM_DIR]=system('echo [%ISSM_DIR_WIN%]');
 		if status, 
-			error('issmssh error message: could not find ISSM_DIR_WIN envirnoment variable');
+			error('issmssh error message: could not find ISSM_DIR_WIN environment variable');
 		end
 		ISSM_DIR=ISSM_DIR(2:end-2);
Index: issm/branches/trunk-jpl-damage/src/m/utils/OS/issmssh.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/OS/issmssh.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/OS/issmssh.py	(revision 12878)
@@ -0,0 +1,42 @@
+import socket
+import platform
+import subprocess
+import os
+from MatlabFuncs import *
+
+def issmssh(host,login,port,command):
+	"""
+	ISSMSSH - wrapper for OS independent ssh command.
+ 
+	    usage: 
+	       issmssh(host,command)
+	"""
+
+	#first get hostname 
+	hostname=socket.gethostname().lower().split('.')[0]
+
+	#if same as host, just run the command. 
+	if strcmpi(host,hostname):
+		subprocess.call(command,shell=True)
+	else:
+		if 'Windows' in platform.system():
+			#use the putty project plink.exe: it should be in the path.
+		
+			#get ISSM_DIR variable
+			if 'ISSM_DIR_WIN' in os.environ:
+				ISSM_DIR=os.environ['ISSM_DIR_WIN'][1:-2]
+			else:
+				raise OSError("issmssh error message: could not find ISSM_DIR_WIN environment variable.")
+
+			username=raw_input('Username: (quoted string) ')
+			key=raw_input('Key: (quoted string) ')
+
+			subprocess.call('%s/externalpackages/ssh/plink.exe -ssh -l "%s" -pw "%s" %s "%s"' % (ISSM_DIR,username,key,host,command),shell=True);
+
+		else:
+			#just use standard unix ssh
+			if port:
+				subprocess.call('ssh -l %s -p %d localhost "%s"' % (login,port,command),shell=True)
+			else:
+				subprocess.call('ssh -l %s %s "%s"' % (login,host,command),shell=True)
+
Index: issm/branches/trunk-jpl-damage/src/m/utils/Shell/issmdir.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Shell/issmdir.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Shell/issmdir.py	(revision 12878)
@@ -0,0 +1,24 @@
+import platform
+import os
+from MatlabFuncs import *
+
+def issmdir():
+	"""
+	ISSMDIR - Get ISSM_DIR environment variable
+ 
+	    Usage:
+	       ISSM_DIR=issmdir()
+	"""
+
+	if not 'Windows' in platform.system():
+		ISSM_DIR =os.environ['ISSM_DIR']
+	else:
+		ISSM_DIR =os.environ['ISSM_DIR_WIN']
+		if strcmpi(ISSM_DIR[-1],'/') or strcmpi(ISSM_DIR[-1],'\\'):
+			ISSM_DIR = ISSM_DIR[:-1]    #shave off the last '/'
+
+	if not ISSM_DIR:
+		raise RuntimeError("issmdir error message: 'ISSM_DIR' environment variable is empty! You should define ISSM_DIR in your .cshrc or .bashrc!")
+
+	return ISSM_DIR
+
Index: issm/branches/trunk-jpl-damage/src/m/utils/consistency/checkfield.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/consistency/checkfield.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/utils/consistency/checkfield.m	(revision 12878)
@@ -1,3 +1,3 @@
-function checkfield(md,fieldname,varargin)
+function md = checkfield(md,fieldname,varargin)
 %CHECKFIELD - check field consistency
 %
@@ -19,10 +19,10 @@
 %
 %   Usage:
-%      checkfield(md,fieldname,options);
+%      md = checkfield(md,fieldname,options);
 %
 %   Example:
-%      checkfield(md,'mesh.elementonbed','size',[md.mesh.numberofelements 1],'values',[0 1]);
-%      checkfield(md,'diagnostic.icefront','size',[NaN 4],'NaN',1);
-%      checkfield(md,'diagnostic.icefront(:,end)','values',[0 1 2]);
+%      md = checkfield(md,'mesh.elementonbed','size',[md.mesh.numberofelements 1],'values',[0 1]);
+%      md = checkfield(md,'diagnostic.icefront','size',[NaN 4],'NaN',1);
+%      md = checkfield(md,'diagnostic.icefront(:,end)','values',[0 1 2]);
 
 %get options
@@ -35,5 +35,5 @@
 if exist(options,'empty')
 	if isempty(field),
-		checkmessage(getfieldvalue(options,'message',...
+		md = checkmessage(md,getfieldvalue(options,'message',...
 			['field ''' fieldname ''' is empty']));
 	end
@@ -45,15 +45,15 @@
 	if isnan(fieldsize(1)),
 		if (size(field,2)~=fieldsize(2)),
-			checkmessage(getfieldvalue(options,'message',...
+			md = checkmessage(md,getfieldvalue(options,'message',...
 				['field ''' fieldname ''' should have ' num2str(fieldsize(2)) ' columns']));
 		end
 	elseif isnan(fieldsize(2)),
 		if (size(field,1)~=fieldsize(1)),
-			checkmessage(getfieldvalue(options,'message',...
+			md = checkmessage(md,getfieldvalue(options,'message',...
 				['field ''' fieldname ''' should have ' num2str(fieldsize(1)) ' lines']));
 		end
 	else
-		if ((size(field)~=fieldsize(1)) |  (size(field,2)~=fieldsize(2)))
-			checkmessage(getfieldvalue(options,'message',...
+		if ((size(field,1)~=fieldsize(1)) |  (size(field,2)~=fieldsize(2)))
+			md = checkmessage(md,getfieldvalue(options,'message',...
 				['field ''' fieldname ''' size should be ' num2str(fieldsize(1)) ' x ' num2str(fieldsize(2))]));
 		end
@@ -66,11 +66,11 @@
 	if ~ismember(numel(field),fieldnumel),
 		if length(fieldnumel)==1
-			checkmessage(getfieldvalue(options,'message',...
+			md = checkmessage(md,getfieldvalue(options,'message',...
 				['field ''' fieldname ''' size should be ' sprintf('%g ',fieldnumel) ]));
 		elseif length(fieldnumel)==2
-			checkmessage(getfieldvalue(options,'message',...
+			md = checkmessage(md,getfieldvalue(options,'message',...
 				['field ''' fieldname ''' size should be ' num2str(fieldnumel(1)) ' or ' num2str(fieldnumel(2)) ]));
 		else
-			checkmessage(getfieldvalue(options,'message',...
+			md = checkmessage(md,getfieldvalue(options,'message',...
 				['field ''' fieldname ''' size should be ' sprintf('%g, ',fieldnumel(1:end-1)) ' or ' num2str(fieldnumel(end)) ]));
 		end
@@ -82,13 +82,13 @@
 	field2=reshape(field,prod(size(field)),1);
 	if any(isnan(field2)),
-		checkmessage(getfieldvalue(options,'message',...
+		md = checkmessage(md,getfieldvalue(options,'message',...
 			['NaN values found in field ''' fieldname '''']));
 	end
 end
 
-%check NaN
+%check cell
 if getfieldvalue(options,'cell',0);
 	if ~iscell(field),
-		checkmessage(getfieldvalue(options,'message',...
+		md = checkmessage(md,getfieldvalue(options,'message',...
 			['field ''' fieldname ''' should be a cell']));
 	end
@@ -99,32 +99,32 @@
 	fieldvalues=getfieldvalue(options,'values');
 	if iscell(fieldvalues), %strings
-	if ischar(field) | iscell(fieldvalues),
-		if any(~ismember(field,fieldvalues)),
-			if length(fieldvalues)==1
-				checkmessage(getfieldvalue(options,'message',...
-					['field ''' fieldname ''' value should be ' fieldvalues{1} ]));
-			elseif length(fieldvalues)==2
-				checkmessage(getfieldvalue(options,'message',...
-					['field ''' fieldname ''' values should be ' fieldvalues{1} ' or ' fieldvalues{2} ]));
-			else
-				checkmessage(getfieldvalue(options,'message',...
-					['field ''' fieldname ''' should have values in ' sprintf('''%s'', ',fieldvalues{1:end-1}) 'or ''' fieldvalues{end} '''']));
+		if ischar(field) | iscell(fieldvalues),
+			if any(~ismember(field,fieldvalues)),
+				if length(fieldvalues)==1
+					md = checkmessage(md,getfieldvalue(options,'message',...
+						['field ''' fieldname ''' value should be ''' fieldvalues{1} '''']));
+				elseif length(fieldvalues)==2
+					md = checkmessage(md,getfieldvalue(options,'message',...
+						['field ''' fieldname ''' values should be ''' fieldvalues{1} ''' or ''' fieldvalues{2} '''']));
+				else
+					md = checkmessage(md,getfieldvalue(options,'message',...
+						['field ''' fieldname ''' should have values in ' sprintf('''%s'', ',fieldvalues{1:end-1}) 'or ''' fieldvalues{end} '''']));
+				end
 			end
+		else
+			md = checkmessage(md,getfieldvalue(options,'message',...
+				['field ''' fieldname ''' should be one of the following strings: ' sprintf('''%s'', ',fieldvalues{1:end-1}) 'or ''' fieldvalues{end} '''']));
 		end
 	else
-		checkmessage(getfieldvalue(options,'message',...
-			['field ''' fieldname ''' should be one of the following strings: ' sprintf('''%s'', ',fieldvalues{1:end-1}) 'or ''' fieldvalues{end} '''']));
-	end
-else
-	field2=reshape(field,prod(size(field)),1);
-	if isnumeric(field),
-		if any(~ismember(field2,fieldvalues)),
-			checkmessage(getfieldvalue(options,'message',...
-				['field ''' fieldname ''' should have values in [' num2str(fieldvalues) ']']));
+		field2=reshape(field,prod(size(field)),1);
+		if isnumeric(field),
+			if any(~ismember(field2,fieldvalues)),
+				md = checkmessage(md,getfieldvalue(options,'message',...
+					['field ''' fieldname ''' should have values in [' num2str(fieldvalues) ']']));
+			end
+		else
+			md = checkmessage(md,getfieldvalue(options,'message',...
+				['field ''' fieldname ''' should be a number in [' num2str(fieldvalues) ']']));
 		end
-	else
-		checkmessage(getfieldvalue(options,'message',...
-			['field ''' fieldname ''' should be a number in [' num2str(fieldvalues) ']']));
-	end
 	end
 end
@@ -135,5 +135,5 @@
 	field2=reshape(field,prod(size(field)),1);
 	if any(field2<lowerbound),
-		checkmessage(getfieldvalue(options,'message',...
+		md = checkmessage(md,getfieldvalue(options,'message',...
 			['field ''' fieldname ''' should have values above ' num2str(lowerbound)]));
 	end
@@ -143,5 +143,5 @@
 	field2=reshape(field,prod(size(field)),1);
 	if any(field2<=lowerbound),
-		checkmessage(getfieldvalue(options,'message',...
+		md = checkmessage(md,getfieldvalue(options,'message',...
 			['field ''' fieldname ''' should have values above ' num2str(lowerbound)]));
 	end
@@ -153,5 +153,5 @@
 	field2=reshape(field,prod(size(field)),1);
 	if any(field2>upperbound),
-		checkmessage(getfieldvalue(options,'message',...
+		md = checkmessage(md,getfieldvalue(options,'message',...
 			['field ''' fieldname ''' should have values below ' num2str(upperbound)]));
 	end
@@ -161,6 +161,6 @@
 	field2=reshape(field,prod(size(field)),1);
 	if any(field2>=upperbound),
-		checkmessage(getfieldvalue(options,'message',...
-			['field ''' fieldname ''' should have values below ' num2str(upperbound(1))]));
+		md = checkmessage(md,getfieldvalue(options,'message',...
+			['field ''' fieldname ''' should have values below ' num2str(upperbound)]));
 	end
 end
@@ -169,5 +169,5 @@
 if getfieldvalue(options,'file',0),
 	if ~exist(field,'file')
-		checkmessage(['file profided in ''' fieldname ''': ''' field ''' does not exist']);
+		md = checkmessage(md,['file provided in ''' fieldname ''': ''' field ''' does not exist']);
 	end
 end
@@ -177,18 +177,18 @@
 	if size(field,1)==md.mesh.numberofvertices,
 		if ~size(field,2)==1,
-			checkmessage(getfieldvalue(options,'message',...
+			md = checkmessage(md,getfieldvalue(options,'message',...
 				['field ''' fieldname ''' should have only one column as there are md.mesh.numberofvertices lines']));
 		end
 	elseif size(field,1)==md.mesh.numberofvertices+1
 		if any(field(end,:)~=sort(field(end,:))),
-			checkmessage(getfieldvalue(options,'message',...
-				['field ''' fieldname ''' columns should be chronological']));
+			md = checkmessage(md,getfieldvalue(options,'message',...
+				['field ''' fieldname ''' columns should be sorted chronologically']));
 		end
 		if any(field(end,1:end-1)==field(end,2:end)),
-			checkmessage(getfieldvalue(options,'message',...
+			md = checkmessage(md,getfieldvalue(options,'message',...
 				['field ''' fieldname ''' columns must not contain duplicate timesteps']));
 		end
 	else
-		checkmessage(getfieldvalue(options,'message',...
+		md = checkmessage(md,getfieldvalue(options,'message',...
 			['field ''' fieldname ''' should have md.mesh.numberofvertices or md.mesh.numberofvertices+1 lines']));
 	end
Index: issm/branches/trunk-jpl-damage/src/m/utils/consistency/checkfield.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/consistency/checkfield.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/utils/consistency/checkfield.py	(revision 12878)
@@ -0,0 +1,150 @@
+import numpy
+import os
+from pairoptions import *
+from MatlabFuncs import *
+
+def checkfield(md,fieldname,*args):
+	"""
+	CHECKFIELD - check field consistency
+
+	    Used to check model consistency.
+	    Available options:
+	       - NaN: 1 if check that there is no NaN
+	       - size: [lines cols], NaN for non checked dimensions
+	       - >:  greater than provided value
+	       - >=: greater or equal to provided value
+	       - <:  smallerthan provided value
+	       - <=: smaller or equal to provided value
+	       - < vec:  smallerthan provided values on each vertex
+	       - forcing: 1 if check forcing consistency (size and time)
+	       - values: cell of strings or vector of acceptable values
+	       - numel: list of acceptable number of elements
+	       - cell: 1 if check that is cell
+	       - empty: 1 if check that non empty
+	       - message: overloaded error message
+
+	    Usage:
+	       md = checkfield(md,fieldname,options);
+
+	    Example:
+	       md = checkfield(md,'mesh.elementonbed','size',[md.mesh.numberofelements 1],'values',[0 1]);
+	       md = checkfield(md,'diagnostic.icefront','size',[NaN 4],'NaN',1);
+	       md = checkfield(md,'diagnostic.icefront(:,end)','values',[0 1 2]);
+	"""
+
+	#get options
+	options=pairoptions(*args)
+
+	#get field from model
+	field=getattr(md,fieldname)
+
+	#check empty
+	if 'empty' in options:
+		if not field:
+			md = md.checkmessage(options.getfieldvalue('message',\
+				"field '%s' is empty" % fieldname))
+
+	#Check size
+	if 'size' in options:
+		fieldsize=options.getfieldvalue('size')
+		if   numpy.isnan(fieldsize[0]):
+			if not numpy.size(field,1)==fieldsize[1]:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' should have %d columns" % (fieldname,fieldsize[1])))
+		elif numpy.isnan(fieldsize[1]):
+			if not numpy.size(field,0)==fieldsize[0]:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' should have %d lines" % (fieldname,fieldsize[0])))
+		else:
+			if (not numpy.size(field,0)==fieldsize[0]) or (not numpy.size(field,1)==fieldsize[1]):
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' size should be %d x %d" % (fieldname,fieldsize[0],fieldsize[1])))
+	
+	#Check numel
+	if 'numel' in options:
+		fieldnumel=options.getfieldvalue('numel')
+		if not numpy.size(field) in fieldnumel:
+			if   len(fieldnumel)==1:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' size should be %d" % (fieldname,fieldnumel)))
+			elif len(fieldnumel)==2:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' size should be %d or %d" % (fieldname,fieldnumel[0],fieldnumel[1])))
+			else:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' size should be %s" % (fieldname,fieldnumel)))
+
+	#check NaN
+	if options.getfieldvalue('NaN',0):
+		if True in numpy.isnan(field):
+			md = md.checkmessage(options.getfieldvalue('message',\
+				"NaN values found in field '%s'" % fieldname))
+
+	#check cell
+	if options.getfieldvalue('cell',0):
+		if not isinstance(field,(tuple,list,dict)):
+			md = md.checkmessage(options.getfieldvalue('message',\
+				"field '%s' should be a cell" % fieldname))
+
+	#check values
+	if 'values' in options:
+		fieldvalues=options.getfieldvalue('values')
+		if False in ismember(field,fieldvalues):
+			if   len(fieldvalues)==1:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' value should be '%s'"  % (fieldname,fieldvalues[0])))
+			elif len(fieldvalues)==2:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' values should be '%s' or '%s'"  % (fieldname,fieldvalues[0],fieldvalues[1])))
+			else:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' should have values in %s" % (fieldname,fieldvalues)))
+
+	#check greater
+	if '>=' in options:
+		lowerbound=options.getfieldvalue('>=')
+		if numpy.any(field<lowerbound):
+			md = md.checkmessage(options.getfieldvalue('message',\
+				"field '%s' should have values above %d" % (fieldname,lowerbound)))
+	if '>' in options:
+		lowerbound=options.getfieldvalue('>')
+		if numpy.any(field<=lowerbound):
+			md = md.checkmessage(options.getfieldvalue('message',\
+				"field '%s' should have values above %d" % (fieldname,lowerbound)))
+
+	#check smaller
+	if '<=' in options:
+		upperbound=options.getfieldvalue('<=')
+		if numpy.any(field>upperbound):
+			md = md.checkmessage(options.getfieldvalue('message',\
+				"field '%s' should have values below %d" % (fieldname,upperbound)))
+	if '<' in options:
+		upperbound=options.getfieldvalue('<')
+		if numpy.any(field>=upperbound):
+			md = md.checkmessage(options.getfieldvalue('message',\
+				"field '%s' should have values below %d" % (fieldname,upperbound)))
+
+	#check file
+	if options.getfieldvalue('file',0):
+		if not os.path.exists(field):
+			md = md.checkmessage("file provided in '%s': '%s' does not exist" % (fieldname,field))
+
+	#Check forcings (size and times)
+	if options.getfieldvalue('forcing',0):
+		if   numpy.size(field,0)==md.mesh.numberofvertices:
+			if not numpy.size(field,1)==1:
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' should have only one column as there are md.mesh.numberofvertices lines" % fieldname))
+		elif numpy.size(field,0)==md.mesh.numberofvertices+1:
+			if not numpy.all(field[-1,:]==numpy.sort(field[-1,:])):
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' columns should be sorted chronologically" % fieldname))
+			if nump.any(field[-1,0:-1]==field[-1,1:]):
+				md = md.checkmessage(options.getfieldvalue('message',\
+					"field '%s' columns must not contain duplicate timesteps" % fieldname))
+		else:
+			md = md.checkmessage(options.getfieldvalue('message',\
+				"field '%s' should have md.mesh.numberofvertices or md.mesh.numberofvertices+1 lines" % fieldname))
+
+	return md
+
Index: issm/branches/trunk-jpl-damage/src/modules/AverageFilter/AverageFilter.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/modules/AverageFilter/AverageFilter.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/modules/AverageFilter/AverageFilter.cpp	(revision 12878)
@@ -53,10 +53,10 @@
 void AverageFilterUsage(void)
 {
-	printf("   AverageFilter usage:\n");
-	printf("   [image_out]=AverageFilter(image_in,pixels);\n\n");
-	printf("   where:\n");
-	printf("      image_in in double format\n");
-	printf("      pixels: characteristic size of smoothing\n");
-	printf("      image_out in double format\n");
-	printf("\n");
+	_printLine_("   AverageFilter usage:");
+	_printLine_("   [image_out]=AverageFilter(image_in,pixels);\n");
+	_printLine_("   where:");
+	_printLine_("      image_in in double format");
+	_printLine_("      pixels: characteristic size of smoothing");
+	_printLine_("      image_out in double format");
+	_printLine_("");
 }
Index: issm/branches/trunk-jpl-damage/src/modules/BamgConvertMesh/BamgConvertMesh.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/modules/BamgConvertMesh/BamgConvertMesh.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/modules/BamgConvertMesh/BamgConvertMesh.cpp	(revision 12878)
@@ -4,25 +4,17 @@
 #include "./BamgConvertMesh.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
+void mexFunction(int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
 
 	/*input: */
-	double* index=NULL;
-	int     index_rows;
-	double* x=NULL;
-	int     x_cols;
-	double* y=NULL;
-	int     y_rows;
-	int     y_cols;
+	int    *index      = NULL;
+	double *x          = NULL;
+	double *y          = NULL;
+	int     nods,nels,test1,test2;
 
 	/*Output*/
-	BamgMesh* bamgmesh=NULL;
-	BamgGeom* bamggeom=NULL;
-	mxArray* bamgmesh_mat=NULL;
-	mxArray* bamggeom_mat=NULL;
-
-	/*Intermediary*/
-	int nods;
-	int nels;
-	int verbose=0;
+	BamgMesh *bamgmesh     = NULL;
+	BamgGeom *bamggeom     = NULL;
+	mxArray  *bamgmesh_mat = NULL;
+	mxArray  *bamggeom_mat = NULL;
 
 	/*Boot module: */
@@ -37,28 +29,15 @@
 
 	/*Input datasets: */
-	if (verbose) printf("Fetching inputs\n");
-	FetchData(&index,&nels,&index_rows,INDEXHANDLE);
-	FetchData(&x,&nods,&x_cols,XHANDLE);
-	FetchData(&y,&y_rows,&y_cols,YHANDLE);
+	FetchData(&index,&nels,&test1,INDEXHANDLE);
+	FetchData(&x,&nods,XHANDLE);
+	FetchData(&y,&test2,YHANDLE);
 
 	/*Check inputs*/
-	if (nels<0){
-		_error_("Number of elements must be positive, check index number of lines");
-	}
-	if (nods<0){
-		_error_("Number of nods must be positive, check x and y sizes");
-	}
-	if (index_rows!=3){
-		_error_("index should have 3 columns");
-	}
-	if (y_rows!=nods){
-		_error_("x and y do not have the same length");
-	}
-	if (x_cols>1 || y_cols>1){
-		_error_("x and y should have only one column");
-	}
+	if(nels<0) _error2_("Number of elements must be positive, check index number of lines");
+	if(nods<0) _error2_("Number of nods must be positive, check x and y sizes");
+	if(test1!=3) _error2_("index should have 3 columns");
+	if(test2!=nods) _error2_("x and y do not have the same length");
 
 	/* Run core computations: */
-	if (verbose) printf("Call core\n");
 	BamgConvertMeshx(bamgmesh,bamggeom,index,x,y,nods,nels);
 
@@ -75,12 +54,11 @@
 }
 
-void BamgConvertMeshUsage(void)
-{
-	_printf_(true,"BAMGCONVERTMESH - convert [x y index] to a bamg geom and mesh geom");
-	_printf_(true,"\n");
-	_printf_(true,"   Usage:\n");
-	_printf_(true,"      [bamggeom bamgmesh]=BamgConvertMesh(index,x,y);\n");
-	_printf_(true,"      index: index of the mesh\n");
-	_printf_(true,"      x,y: coordinates of the nodes\n");
-	_printf_(true,"\n");
+void BamgConvertMeshUsage(void){
+	_pprintString_("BAMGCONVERTMESH - convert [x y index] to a bamg geom and mesh geom");
+	_pprintLine_("");
+	_pprintLine_("   Usage:");
+	_pprintLine_("      [bamggeom bamgmesh]=BamgConvertMesh(index,x,y);");
+	_pprintLine_("      index: index of the mesh");
+	_pprintLine_("      x,y: coordinates of the nodes");
+	_pprintLine_("");
 }
Index: issm/branches/trunk-jpl-damage/src/modules/BamgMesher/BamgMesher.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/modules/BamgMesher/BamgMesher.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/modules/BamgMesher/BamgMesher.cpp	(revision 12878)
@@ -51,6 +51,6 @@
 
 void BamgMesherUsage(void){
-	_printf_(true,"\n");
-	_printf_(true,"   usage: [bamgmesh,bamggeom]=%s(bamgmesh,bamggeom,bamgoptions);\n",__FUNCT__);
-	_printf_(true,"\n");
+	_pprintLine_("");
+	_pprintLine_("   usage: [bamgmesh,bamggeom]=" << __FUNCT__ << "(bamgmesh,bamggeom,bamgoptions);");
+	_pprintLine_("");
 }
